## dtkai 0.0.1

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)

# If do't define version number, specify the version number
set(VERSION "1.0.0" CACHE STRING "define project version")

project(dtkai
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtkai
    DESCRIPTION "dtk library for dtkai."
    VERSION ${VERSION}
)

# specify install dir
include(GNUInstallDirs)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_FLAGS Release CACHE STRING "define CXXFLAGS")

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
message("Using Qt version: ${QT_VERSION_MAJOR}")

if(QT_VERSION_MAJOR EQUAL "6")
    set(DTK_VERSION_MAJOR 6)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_EXAMPLES ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
endif()

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core DBus)
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED Core)
add_compile_definitions(QT_NO_SIGNALS_SLOTS_KEYWORDS)

# src
add_subdirectory(src)

# example
if (BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

=== examples/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_subdirectory(chat)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME dtkai)

file(GLOB_RECURSE INCLUDE_FILES "${PROJECT_SOURCE_DIR}/include/${BIN_NAME}/*")
file(GLOB_RECURSE SRCS
    "*/*.h"
    "*/*.cpp"
)

if(QT_VERSION_MAJOR EQUAL "5")
    qt5_add_dbus_interface(DBUS_FILES ${CMAKE_SOURCE_DIR}/3rdparty/aidaemon/org.deepin.ai.daemon.apiserver.xml aidaemon_apiserver)
    qt5_add_dbus_interface(DBUS_FILES ${CMAKE_SOURCE_DIR}/3rdparty/aidaemon/org.deepin.ai.daemon.apisession.chat.xml aidaemon_apisession_chat)
    qt5_add_dbus_interface(DBUS_FILES ${CMAKE_SOURCE_DIR}/3rdparty/aidaemon/org.deepin.ai.daemon.apisession.functioncalling.xml aidaemon_apisession_functioncalling)
else()
    qt_add_dbus_interface(DBUS_FILES ${CMAKE_SOURCE_DIR}/3rdparty/aidaemon/org.deepin.ai.daemon.apiserver.xml aidaemon_apiserver)
    qt_add_dbus_interface(DBUS_FILES ${CMAKE_SOURCE_DIR}/3rdparty/aidaemon/org.deepin.ai.daemon.apisession.chat.xml aidaemon_apisession_chat)
    qt_add_dbus_interface(DBUS_FILES ${CMAKE_SOURCE_DIR}/3rdparty/aidaemon/org.deepin.ai.daemon.apisession.functioncalling.xml aidaemon_apisession_functioncalling)
endif()

message(${DBUS_FILES})

add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${SRCS}
    ${DBUS_FILES}
)

target_include_directories(${BIN_NAME} PUBLIC ${PROJECT_SOURCE_DIR}/include/${BIN_NAME}/)

set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED Core)
find_package(PkgConfig REQUIRED)
target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Dtk${DTK_VERSION_MAJOR}::Core
)

install(FILES ${INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

# for pc file config
set(PC_LIBS_PRIVATE Qt${QT_VERSION_MAJOR}Core)
set(PC_REQ_PRIVATE)
set(PC_REQ_PUBLIC)

# config pkgconfig file
configure_file(${PROJECT_SOURCE_DIR}/misc/${BIN_NAME}/${BIN_NAME}.pc.in ${BIN_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# config cmake file
configure_file(${PROJECT_SOURCE_DIR}/misc/${BIN_NAME}/${BIN_NAME}Config.cmake.in ${BIN_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${BIN_NAME})

# config qmake moudule file
set(DTK_MODULE ${BIN_NAME})
set(DTK_DEPS "core dbus")
set(QMKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")
configure_file(${PROJECT_SOURCE_DIR}/misc/${BIN_NAME}/qt_lib_${BIN_NAME}.pri.in qt_lib_${BIN_NAME}.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_${BIN_NAME}.pri DESTINATION "${QMKSPECS_INSTALL_DIR}")

=== examples/chat/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(chat VERSION 1.0 LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core REQUIRED)
find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Core REQUIRED)
#find_package(dtkai REQUIRED)

add_executable(
    chat
    chat.cpp
)

add_executable(
    chat_stream
    chat_stream.cpp
)

add_executable(
    functioncalling
    functioncalling.cpp
)

target_link_libraries(
    chat PRIVATE
    ${DtkCore_LIBRARIES}
    dtkai
)

target_link_libraries(
    chat_stream PRIVATE
    ${DtkCore_LIBRARIES}
    dtkai
)

target_link_libraries(
    functioncalling PRIVATE
    ${DtkCore_LIBRARIES}
    dtkai
)

=== debian/changelog ===
dtkai (0.0.1) unstable; urgency=medium

  * Initial release

 -- Zhang Yu <zhangyub@uniontech.com>  Wed, 28 Aug 2024 16:40:00 +0800

=== debian/control ===
Source: dtkai
Section: libdevel
Priority: optional
Maintainer: Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 pkg-config,
 qhelpgenerator-qt5 | qttools5-dev-tools,
 qtbase5-dev,
 qttools5-dev,
 libdtkcore-dev
Standards-Version: 4.5.0

Package: libdtkai
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin Tool Kit AI library
 libdtkai is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkai-dev
Architecture: any
Depends:${misc:Depends}, libdtkai( =${binary:Version})
Description: Deepin Tool Kit AI devel library
 libdtkio-dev is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries.
